#ifndef MAP_H
#define MAP_H 

extern const int dim_x;
extern const int dim_y;

#include <stdbool.h>
#include "item.h"

typedef enum
{
    EARTH       = 0,
    WATER       = 1,
    MOUNTAIN    = 2

} map_terrain;

struct generic_map // map à l'échelle d'un point
{
    map_terrain terrain;
    bool explored; // brouillard de guerre
    generic_item item;
};
typedef struct generic_map generic_map;



void create_map();

// hidden true, shown false
bool get_visibility(int x, int y);

generic_item* get_item(int x, int y);
void set_item(int x, int y, generic_item const * const item);

void display();

#endif